// ----------------------------------------------------------------------------
//
// umFish(umFish.PAS)                                     Ulrich Mller 12.8.99
//                                                        Procida 400NT Delphi4
// Deklarationen und Variable zu umFish.DLL
//
// ----------------------------------------------------------------------------

unit umFishS;

interface

const
  ftiAus=0; ftiEin=1; ftiLinks=1; ftiRechts=2;
  ftiFehler=$0001FFFF; ftiTrue=-1; ftiFalse=0;

type TftiDCB = record
  hCom: LongInt;
  PortID: LongInt;
  LPTDelay: LongInt;
  LPTAnalog: LongInt;
  InputStatus: LongInt;
  MotorStatus: LongInt;
  end;
type TpftiDCB = ^TftiDCB;

function OpenInterface(ft: TpftiDCB; PortName: string):LongInt;
       stdcall; external 'umFish.dll';
function CloseInterface(ft: TpftiDCB):LongInt;
       stdcall; external 'umFish.dll';
function GetInput(ft: TpftiDCB; InputNr:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function GetInputs(ft: TpftiDCB):LongInt;
       stdcall; external 'umFish.dll';
function ClearMotors(ft: TpftiDCB):LongInt;
       stdcall; external 'umFish.dll';
function SetMotors(ft: TpftiDCB; MotorStatus:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function SetMotor(ft: TpftiDCB; MotorNr, Direction:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function SetLamp(ft: TpftiDCB; LampNr, OnOff:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function GetAnalog(ft: TpftiDCB; AnalogNr:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function StartDriver():LongInt; stdcall; external 'umFish.dll';
function StopDriver():LongInt; stdcall; external 'umFish.dll';

procedure AllesAus;
function  AusgangZustand():Word;
procedure Ausschalten(Nr: Word);
procedure EinSchalten(Nr: Word);
procedure ftAus;
procedure ftEin;
procedure Motor(Nr, Richtung: Word);
procedure Pause(zSek: Word);
function  Poti(Nr: Word):Word;
function  SchalterAn(Nr: Word):Boolean;
function  Sensor(Nr: Word):Word;

implementation

uses
  Windows, Messages, SysUtils, Forms, Dialogs;
var
  ftiDCB: TftiDCB; pftiDCB: TpftiDCB = @ftiDCB;

procedure AllesAus;
begin
  ClearMotors(pftiDCB);
  Application.ProcessMessages;
end;
function AusgangZustand():Word;
begin
  Result := ftiDCB.MotorStatus;
  Application.ProcessMessages;
end;
procedure Ausschalten(Nr: Word);
begin
  SetLamp(pftiDCB, Nr, ftiAus);
  Application.ProcessMessages;
end;
procedure Einschalten(Nr: Word);
begin
  SetLamp(pftiDCB, Nr, ftiEin);
  Application.ProcessMessages;
end;
procedure ftAus;
begin
  CloseInterface(pftiDCB);
  StopDriver;
end;
procedure ftEin;
begin
  StartDriver;
  if OpenInterface(pftiDCB, 'LPT') = ftiFehler then MessageDlg('InterfaceProblem', mtWarning, [mbOK], 0);
end;
procedure Motor(Nr, Richtung: Word);
begin
  setMotor(pftiDCB, Nr, Richtung);
  Application.ProcessMessages;
end;
procedure Pause(zSek: Word);
var sZeit: DWORD;
begin
  sZeit := GetTickCount;
  repeat
    Application.ProcessMessages;
    GetInputs(pftiDCB);
    Application.ProcessMessages;
  until (GetTickCount - sZeit) > zSek*100;
end;
function Poti(Nr: Word):Word;
begin
  Result := GetInput(pftiDCB, Nr);
  Application.ProcessMessages;
end;
function SchalterAn(Nr: Word):Boolean;
var res: LongInt;
begin
  res := GetInput(pftiDCB, Nr);
  if res = ftiTrue then Result := true else Result := false;
  Application.ProcessMessages;
end;
function Sensor(Nr: Word):Word;
begin
  Result := GetAnalog(pftiDCB, Nr);
  Application.ProcessMessages;
end;

end.
